#if !defined(_APIP_H_)
#define _APIP_H_

#ifdef __cplusplus
extern "C" {
#endif

#if !defined(_PARI_H_) || !defined(__GENPARI__)
#define _PARI_H_
#define __GENPARI__
#include <pari.h>
#endif

#include "apip_config.h"

GEN  apip_alloc_pairing(GEN curve, GEN charac, GEN f1_defpol, GEN f2_defpol,
                        GEN g1_order, GEN sfamily, GEN sname);
void apip_free_pairing(GEN gen_pdata);
void apip_set_coord(GEN gen_pdata, char* coordsys);
void apip_set_miller(GEN gen_pdata, char* miller);
void apip_set_name(GEN gen_pdata, char* name);
void apip_set_family(GEN gen_pdata, char* family);
void apip_set_family_param(GEN gen_pdata, GEN u);
void apip_set_denom_elim(GEN gen_pdata, long do_denom_elim);
void apip_set_do_reduce(GEN gen_pdata, long do_reduce);
void apip_set_do_naive_exp(GEN gen_pdata, long do_naive_exp);
void apip_set_do_naive_hard_exp(GEN gen_pdata, long do_naive_hard_exp);
void apip_set_frob_trace(GEN gen_pdata, GEN t);
GEN  apip_weil(GEN gen_pdata, GEN P, GEN Q);
GEN  apip_tate(GEN gen_pdata, GEN P, GEN Q);
GEN  apip_ate(GEN gen_pdata, GEN P, GEN Q);
GEN  apip_final_exp(GEN gen_pdata, GEN unreduced);
void apip_print_pairing(GEN gen_pdata);
void apip_print_avma();
void apip_set_stats_verbosity(ulong verbosity);
void apip_set_stats_ratios(GEN g1_sm, GEN g2_sm, GEN g1_im, GEN g2_im);
void apip_set_r(GEN gen_pdata, int r);

#ifdef __cplusplus
}
#endif
#endif
