#if !defined(_APIP_CHAR_P_JACOBIAN_H_)
#define _APIP_CHAR_P_JACOBIAN_H_

#if !defined(_PARI_H_)
    #define _PARI_H_
    #include <pari.h>
#endif

#include "pairings.h"

#ifdef __cplusplus
extern "C" {
#endif


//----------------------------------------------------------------------------
GEN mul_jac_fp(pairing_data_t* pdata, GEN a, GEN P);
GEN add_jac_fp(pairing_data_t* pdata, GEN P1, GEN P2);
GEN double_jac_fp(pairing_data_t* pdata, GEN P);
GEN mul_jac_fpxq(pairing_data_t* pdata, GEN a, GEN Q);
GEN add_jac_fpxq(pairing_data_t* pdata, GEN Q1, GEN Q2);
GEN double_jac_fpxq(pairing_data_t* pdata, GEN Q);
//----------------------------------------------------------------------------
void update_chord_jac_fp_fpxq(pairing_data_t* pdata, GEN P, GEN Q);
void update_tangent_jac_fp_fpxq(pairing_data_t* pdata, GEN Q);
GEN  eval_vert_jac_fp_fpxq(pairing_data_t* pdata, GEN P, GEN Q);
void update_chord_jac_fpxq_fp(pairing_data_t* pdata, GEN P, GEN Q);
void update_tangent_jac_fpxq_fp(pairing_data_t* pdata, GEN Q);
GEN  eval_vert_jac_fpxq_fp(pairing_data_t* pdata, GEN P, GEN Q);
//----------------------------------------------------------------------------
GEN std_miller_jac_fp_fpxq(pairing_data_t* pdata, GEN r, GEN P, GEN Q);
GEN naf_miller_jac_fp_fpxq(pairing_data_t* pdata, GEN r, GEN P, GEN Q);
GEN std_miller_jac_fpxq_fp(pairing_data_t* pdata, GEN r, GEN Q, GEN P);
GEN naf_miller_jac_fpxq_fp(pairing_data_t* pdata, GEN r, GEN Q, GEN P);
//----------------------------------------------------------------------------

#ifdef __cplusplus
}
#endif
#endif
